package com.mortals.xhx.module.dept.web;
import com.mortals.framework.annotation.UnAuth;
import com.mortals.framework.common.Rest;
import com.mortals.framework.model.PageInfo;
import com.mortals.framework.model.Result;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.module.dept.model.vo.DeptSummaryTopQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.dept.model.DeptPerformStatEntity;
import com.mortals.xhx.module.dept.service.DeptPerformStatService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import java.util.Arrays;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 部门绩效分数统计
*
* @author zxfei
* @date 2023-05-16
*/
@RestController
@RequestMapping("dept/perform/stat")
public class DeptPerformStatController extends BaseCRUDJsonBodyMappingController<DeptPerformStatService,DeptPerformStatEntity,Long> {

    @Autowired
    private ParamService paramService;

    public DeptPerformStatController(){
        super.setModuleDesc( "部门绩效分数统计");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "month", paramService.getParamBySecondOrganize("DeptPerformStat","month"));
        this.addDict(model, "day", paramService.getParamBySecondOrganize("DeptPerformStat","day"));
        super.init(model, context);
    }

    /**
     * 部门绩效排行榜
     * @param query
     * @return
     */
    @PostMapping({"summary/top"})
    @UnAuth
    public Rest<Object> getSummaryTopList(@RequestBody DeptSummaryTopQuery query) {
        Rest<Object> ret = new Rest();
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        String busiDesc = "查询部门绩效排行榜";
        int code = 1;
        try {
            List<DeptPerformStatEntity> result = this.getService().getSummaryTopList(query);
            model.put("data", result);
            model.put("message_info", busiDesc + "成功");
            if (!ObjectUtils.isEmpty(context) && !ObjectUtils.isEmpty(context.getUser())) {
                this.recordSysLog(this.request, busiDesc + " 【成功】");
            }
        } catch (Exception var9) {
            code = -1;
            this.doException(this.request, busiDesc, model, var9);
        }
        this.init(model, context);
        ret.setCode(code);
        ret.setData(model.get("data"));
        ret.setMsg(model.get("message_info") == null ? "" : model.remove("message_info").toString());
        return ret;
    }

}